unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, shellapi;

type
  TformMenuPrincipal = class(TForm)
    mCapturas: TMemo;
    bIniciar: TButton;
    tTemporizador: TTimer;
    txtIntervalo: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    opCapturarBotonIzquierdo: TCheckBox;
    tTemporizadorClic: TTimer;
    bLimpiar: TButton;
    bGuardar: TButton;
    dlGuardar: TSaveDialog;
    Label14: TLabel;
    procedure tTemporizadorTimer(Sender: TObject);
    procedure bIniciarClick(Sender: TObject);
    procedure tTemporizadorClicTimer(Sender: TObject);
    procedure bLimpiarClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure Label14Click(Sender: TObject);
  private
    { Private declarations }
    botonPulsado : boolean;
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

{$R *.dfm}

function botonRatonPulsado (ABtn: integer): boolean;
//ABtn can be either VK_LBUTTON, VK_MBUTTON, or VK_RBUTTON
begin
  result := (GetAsyncKeyState(ABtn) and $8000) = $8000;
end;

procedure TformMenuPrincipal.tTemporizadorTimer(Sender: TObject);
var
  posicionCursor : TPoint;
begin
  tTemporizadorClic.Enabled := false;
  if opCapturarBotonIzquierdo.Checked and botonPulsado then
  begin
    GetCursorPos (posicionCursor);
    mCapturas.Lines.Add (inttostr(posicionCursor.X) + ',' +
        inttostr(posicionCursor.Y) + ' - Botn izquierdo pulsado');
    botonPulsado := false;
  end;
  if not opCapturarBotonIzquierdo.Checked then
  begin
    GetCursorPos (posicionCursor);
    mCapturas.Lines.Add (inttostr(posicionCursor.X) + ',' +
        inttostr(posicionCursor.Y));
  end;
  if opCapturarBotonIzquierdo.Checked then
    tTemporizadorClic.Enabled := true;
end;

procedure TformMenuPrincipal.bIniciarClick(Sender: TObject);
begin
  botonPulsado := false;
  tTemporizadorClic.Enabled := opCapturarBotonIzquierdo.Checked;
  if tTemporizador.Enabled then
    bIniciar.Caption := 'Iniciar captura'
  else
  begin
    bIniciar.Caption := 'Detener captura';
    try
      tTemporizador.Interval := StrToInt(txtIntervalo.Text);
    except
      MessageDlg('Debe introducir un nmero de segundos vlido.', mtWarning, [mbok], 0);
      txtIntervalo.SetFocus;
      Exit;
    end;
  end;
  tTemporizador.Enabled := not tTemporizador.Enabled;
end;

procedure TformMenuPrincipal.tTemporizadorClicTimer(Sender: TObject);
begin
  if botonRatonPulsado (VK_LBUTTON) then
    botonPulsado := true;
end;

procedure TformMenuPrincipal.bLimpiarClick(Sender: TObject);
begin
  mCapturas.Clear;
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  tTemporizador.Enabled := false;
  if dlGuardar.Execute then
    mCapturas.Lines.SaveToFile(dlGuardar.FileName);
  tTemporizador.Enabled := true;
end;

procedure TformMenuPrincipal.Label14Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

end.
